## GtkSearchBar GtkSearchBar — A toolbar to integrate a search entry with |

## Functions

GtkWidget * | gtk_search_bar_new ()
void | gtk_search_bar_connect_entry ()
gboolean | gtk_search_bar_get_search_mode ()
void | gtk_search_bar_set_search_mode ()
gboolean | gtk_search_bar_get_show_close_button ()
void | gtk_search_bar_set_show_close_button ()
gboolean | gtk_search_bar_handle_event ()

## Properties

gboolean | search-mode-enabled | Read / Write
gboolean | show-close-button | Read / Write / Construct

## Types and Values

struct | GtkSearchBar
struct | GtkSearchBarClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkBin
                        ╰── GtkSearchBar

## Implemented Interfaces

GtkSearchBar implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

GtkSearchBar is a container made to have a search entry (possibly with additional connex widgets, such as drop-down menus, or buttons) built-in. The search bar would appear when a search is started through typing on the keyboard, or the application’s search mode is toggled on.

For keyboard presses to start a search, events will need to be forwarded from the top-level window that contains the search bar. See `gtk_search_bar_handle_event()` for example code. Common shortcuts such as Ctrl+F should be handled as an application action, or through the menu items.

You will also need to tell the search bar about which entry you are using as your search entry using `gtk_search_bar_connect_entry()`. The following example shows you how to create a more complex search entry.

### CSS nodes

GtkSearchBar has a single CSS node with name searchbar.

#### Creating a search bar

A simple example

## Functions

### gtk_search_bar_new ()

    GtkWidget *
    gtk_search_bar_new (void);

Creates a GtkSearchBar. You will need to tell it about which widget is going to be your text entry using `gtk_search_bar_connect_entry()`.

#### Returns

a new GtkSearchBar

Since: 3.10

### gtk_search_bar_connect_entry ()

    void
    gtk_search_bar_connect_entry (GtkSearchBar *bar,
                                  GtkEntry *entry);

Connects the GtkEntry widget passed as the one to be used in this search bar. The entry should be a descendant of the search bar. This is only required if the entry isn’t the direct child of the search bar (as in our main example).

#### Parameters

bar | a GtkSearchBar |
entry | a GtkEntry |

Since: 3.10

### gtk_search_bar_get_search_mode ()

    gboolean
    gtk_search_bar_get_search_mode (GtkSearchBar *bar);

Returns whether the search mode is on or off.

#### Parameters

bar | a GtkSearchBar |

#### Returns

whether search mode is toggled on

Since: 3.10

### gtk_search_bar_set_search_mode ()

    void
    gtk_search_bar_set_search_mode (GtkSearchBar *bar,
                                    gboolean search_mode);

Switches the search mode on or off.

#### Parameters

bar | a GtkSearchBar |
search_mode | the new state of the search mode |

Since: 3.10

### gtk_search_bar_get_show_close_button ()

    gboolean
    gtk_search_bar_get_show_close_button (GtkSearchBar *bar);

Returns whether the close button is shown.

#### Parameters

bar | a GtkSearchBar |

#### Returns

whether the close button is shown

Since: 3.10

### gtk_search_bar_set_show_close_button ()

    void
    gtk_search_bar_set_show_close_button (GtkSearchBar *bar,
                                          gboolean visible);

Shows or hides the close button. Applications that already have a “search” toggle button should not show a close button in their search bar, as it duplicates the role of the toggle button.

#### Parameters

bar | a GtkSearchBar |
visible | whether the close button will be shown or not |

Since: 3.10

### gtk_search_bar_handle_event ()

    gboolean
    gtk_search_bar_handle_event (GtkSearchBar *bar,
                                 GdkEvent *event);

This function should be called when the top-level window which contains the search bar received a key event.

If the key event is handled by the search bar, the bar will be shown, the entry populated with the entered text and `GDK_EVENT_STOP` will be returned. The caller should ensure that events are not propagated further.

If no entry has been connected to the search bar, using `gtk_search_bar_connect_entry()`, this function will return immediately with a warning.

#### Showing the search bar on key presses

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    static gboolean
    on_key_press_event (GtkWidget *widget,
                        GdkEvent  *event,
                        gpointer   user_data)
    {
      GtkSearchBar *bar = GTK_SEARCH_BAR (user_data);
      return gtk_search_bar_handle_event (bar, event);
    }

    g_signal_connect (window,
                     "key-press-event",
                      G_CALLBACK (on_key_press_event),
                      search_bar);

#### Parameters

bar | a GtkSearchBar |
event | a GdkEvent containing key press events |

#### Returns

`GDK_EVENT_STOP` if the key press event resulted in text being entered in the search entry (and revealing the search bar if necessary), `GDK_EVENT_PROPAGATE` otherwise.

Since: 3.10

## Types and Values

### struct GtkSearchBar

    struct GtkSearchBar;

### struct GtkSearchBarClass

    struct GtkSearchBarClass {
      GtkBinClass parent_class;
    };

#### Members

## Property Details

### The `“search-mode-enabled”` property

      “search-mode-enabled”      gboolean

Whether the search mode is on and the search bar shown.

Flags: Read / Write

Default value: FALSE

### The `“show-close-button”` property

      “show-close-button”        gboolean

Whether to show the close button in the toolbar.

Flags: Read / Write / Construct

Default value: FALSE